/** Sakura Application Copyright(c) 2001 Waku Waku */
import java.applet.Applet;
import java.awt.*;
import java.awt.image.*;
public class WJRunner extends Frame implements Runnable
{
	Thread th=null;
	Image img[]=new Image[2],off,back;
	Graphics g;
	public static final int max=20,w=320,h=320,a=13;
	
	public static void main(String[] args)
	{
		new WJRunner().init();
	}
	public boolean handleEvent(Event e)
	{
		if(e.id==e.WINDOW_DESTROY)
		{
			this.dispose();
			System.exit(0);
		}
		return super.handleEvent(e);
	}
	public void init()
	{
		setSize(w,h);
		setBackground(Color.black);
		setTitle("WJRunner TestApplication");
		show();
		Toolkit tk=getToolkit();
		img[0]=tk.getImage("sakura.gif");
		img[1]=tk.getImage("sakura2.gif");
		mkImage();
		start();
	}
	public void start()
	{
		off=createImage(w,h);
		back=createImage(w,h);
		Graphics gg=back.getGraphics();
		gg.setColor(Color.gray);
		gg.drawString("<This is WJRunner TestApplication.>",70,100);
		gg.drawString("L̃t@C͍폜Ă\܂B",50,130);
		gg.drawString(" WJRunner.class",50,150);
		gg.drawString(" WJRunner.java",50,170);
		gg.drawString(" sakura.gif",50,190);
		gg.drawString(" sakura2.gif",50,210); 
		g=off.getGraphics();
		g.setColor(Color.black);
		th=new Thread(this);
		th.start();
	}
	public void run()
	{
		int[] x=new int[max],y=new int[max],m=new int[max],d=new int[max],s=new int[max];
		boolean[] b=new boolean[max];
		for(int i=0;i<max;i++)
		{
			x[i]=(int)(Math.random()*(w-20));
			y[i]=(int)(-Math.random()*h-30);
			m[i]=(int)(Math.random()*2*a-a);
			d[i]=(i<max/2)?1:0;
			b[i]=((int)(Math.random())==0)?true:false;
			s[i]=(int)(Math.random()*3+5);
		}
		while(true)
		{
			g.drawImage(back,0,0,this);
			for(int i=0;i<max;i++)
			{
				if(m[i]==a || m[i]==-a)
					b[i]=!b[i];
				m[i]+=(b[i])?1:-1;
				x[i]+=m[i];
				if(y[i]<h)
					y[i]+=s[i];
				else
				{
					y[i]=-(int)(Math.random()*5)-img[d[i]].getHeight(this);
					x[i]=(int)(Math.random()*(w-20));
				}
				g.drawImage(img[d[i]],x[i],y[i],this);
			}
			repaint();
			try
			{
				th.sleep(70);
			}catch(InterruptedException e){}
		}
	}
	public void update(Graphics g)
	{
		paint(g);
	}
	public void paint(Graphics g)
	{
		g.drawImage(off,0,0,this);
	}
	public void mkImage()
	{
		MediaTracker mt=new MediaTracker(this);
		mt.addImage(img[0],0);
		mt.addImage(img[1],1);
		try
		{
			mt.waitForAll();
		}catch(Exception e){}
	}
}
